<template>
  <lazy-theme-desktop-china-components-no-game
    v-if="!gameEntrySelected.length"
  />
  <!-- eslint-disable max-len -->
  <div
    v-else
    class="w-full min-w-[1230px] relative bg-[#f0f6ff] h-[960px] pt-[200px]"
  >
    <div class="w-[1200px] mx-auto flex items-center">
      <div class="w-[625px] h-[650px] relative flex justify-start">
        <div
          v-if="activeTab === 'lottery'"
          class="absolute z-0 flex justify-start w-full page-banner-logo"
        >
          <transition appear mode="out-in">
            <img
              v-if="!isDisappear"
              id="pageBannerImg"
              :src="
                handleImportImage(
                  `/light_flexible_1/desktop/images/${folderName}/${bannerImg}.png`
                )
              "
            />
          </transition>
        </div>
        <div :class="animation">
          <Transition>
            <img
              v-if="!isDisappear"
              class="max-w-[550px] absolute z-10"
              :src="
                handleImportImage(
                  `/light_flexible_1/desktop/images/${folderName}/${imgName}.png`
                )
              "
            />
          </Transition>
        </div>
        <div
          v-if="activeTab === 'lottery'"
          class="lottery-animation z-10 top-[-45px] max-w-[550px] absolute static_animation casino_banner_right dice_animation"
        >
          <transition>
            <img
              v-if="!isDisappear"
              :src="
                getAssetImage(
                  'assets/theme/light_flexible_1/desktop/images/lotteryPage/lotteryball.png'
                )
              "
              alt=""
            />
          </transition>
        </div>
        <div v-if="activeTab === 'livecasino'">
          <div class="coin_fade">
            <transition>
              <img
                v-if="!isDisappear"
                class="top-[55px] right-[63px] w-14 h-[54px] absolute z-[1] live_casino_animation casino_banner_left coin1_animation"
                :src="
                  getAssetImage(
                    'assets/theme/light_flexible_1/desktop/images/casinoPage/coin_1.png'
                  )
                "
                alt=""
              />
            </transition>
          </div>
          <div class="coin_fade">
            <transition>
              <img
                v-if="!isDisappear"
                class="top-[52px] right-[150px] w-[39px] h-[30px] absolute z-[10] live_casino_animation casino_banner_left coin2_animation"
                :src="
                  getAssetImage(
                    'assets/theme/light_flexible_1/desktop/images/casinoPage/coin_2.png'
                  )
                "
                alt=""
              />
            </transition>
          </div>
          <div :class="animation">
            <transition>
              <img
                v-if="!isDisappear"
                class="w-[121px] top-[213px] left-[-40px] absolute z-[1] h-[81px] live_casino_animation casino_banner_left pyramid_animation"
                :src="
                  getAssetImage(
                    'assets/theme/light_flexible_1/desktop/images/casinoPage/pyramidgreendragon.png'
                  )
                "
                alt=""
              />
            </transition>
          </div>
          <div :class="animation">
            <transition>
              <img
                v-if="!isDisappear"
                class="top-[388px] left-[50px] w-[66px] h-[63px] absolute z-[1] static_animation casino_banner_left dice_animation"
                :src="
                  getAssetImage(
                    'assets/theme/light_flexible_1/desktop/images/casinoPage/dice.png'
                  )
                "
                alt=""
              />
            </transition>
          </div>
        </div>
      </div>
      <div class="w-[500px] h-[650px] relative sport_company_logo">
        <div class="h-[330px]">
          <transition appear>
            <div v-if="!isDisappear" class="relative w-full">
              <div class="sport_info">
                <div>
                  <div>
                    <img
                      class="w-500 h-[148px]"
                      :src="
                        handleImportImage(
                          `/light_flexible_1/desktop/images/${folderName}/font${imgName}.png`
                        )
                      "
                      alt="logo"
                    />
                  </div>
                </div>
                <div class="my-[20px] text-[16px] font-medium">
                  <span v-if="!$t(gameEntrySelected[currentIndex].IntroForDisplay.short).includes('_')">{{
                    $t(gameEntrySelected[currentIndex].IntroForDisplay.short)
                  }}</span>
                </div>
                <div v-if="activeTab !== 'lottery'" class="flex w-full">
                  <img
                    class="max-h-[40px]"
                    :src="
                      getAssetImage(
                        'assets/theme/light_flexible_1/desktop/images/casinoPage/casinolist.png'
                      )
                    "
                    alt=""
                  />
                </div>
                <div v-if="activeTab === 'lottery'" class="flex w-full">
                  <img
                    class="max-h-[40px]"
                    :src="
                      getAssetImage(
                        'assets/theme/light_flexible_1/desktop/images/lotteryPage/lotterylist.png'
                      )
                    "
                    alt=""
                  />
                </div>
              </div>
            </div>
          </transition>
        </div>
        <div class="relative">
          <div
            class="max-h-64 w-[525px] sport swiper game-banner-swiper swiper-initialized swiper-horizontal swiper-pointer-events swiper-backface-hidden"
          >
            <section
              class="flex flex-col h-[183px] items-center swiper-slide swiper-slide-active"
            >
              <swiper
                :slides-per-view="5"
                :modules="modules"
                :navigation="gameEntrySelected.length > 6"
                class="swiper-wrapper casino-swiper"
              >
                <template
                  v-for="(game, index) in gameEntrySelected"
                  :key="index"
                  class="filter-item"
                >
                  <swiper-slide
                    v-if="game !== undefined"
                    class="flex flex-col items-center w-4/12 swiper-slide"
                  >
                    <div
                      class="cursor-pointer group"
                      :class="
                        handleRemoveSpaceSpecialCharFormatted(
                          String(game.EnglishGameName).concat(game.GameProviderId === 1052 ? 'new' : '')
                        ) === imgName
                          ? 'sport_tab_active'
                          : 'sport_tab'
                      "
                      @click="toggleTab(game, index)"
                    >
                      <div>
                        <img
                          class="w-[32px] h-[32px] img-inactive"
                          :class="
                            handleRemoveSpaceSpecialCharFormatted(
                              String(game.EnglishGameName)
                            ) !== imgName
                              ? 'block'
                              : 'hidden'
                          "
                          :src="
                            handleImportImage(
                              `/light_flexible_1/desktop/images/productHover/${checkImgName(
                                handleRemoveSpaceSpecialCharFormatted(
                                  String(game.EnglishGameName)
                                )
                              )}logo.png`
                            )
                          "
                          alt="logo"
                        />
                        <img
                          class="w-[32px] h-[32px] img-active"
                          :class="
                            handleRemoveSpaceSpecialCharFormatted(
                              String(game.EnglishGameName)
                            ) === imgName
                              ? 'block'
                              : 'hidden'
                          "
                          :src="
                            handleImportImage(
                              `/light_flexible_1/desktop/images/productHover/activeIco/${checkImgName(
                                handleRemoveSpaceSpecialCharFormatted(
                                  String(game.EnglishGameName)
                                )
                              )}logo.png`
                            )
                          "
                          alt="logo"
                        />
                      </div>
                    </div>
                    <div
                      class="py-3 text-center text-[14px] font-medium w-[76px] break-words">
                      <span>{{ game.GameNameForDisplay }}</span>
                    </div>
                  </swiper-slide>
                </template>
              </swiper>
            </section>
          </div>
        </div>
        <div
          class="w-full h-[100px] flex justify-start items-start mt-[47px] cursor-pointer"
          :style="`--btnBg: ${btnBg};`"
        >
          <div
            class="flex items-center justify-center text-lg sport-entry-play-button"
            @click="onPlay(selectedCasino?.GameId)"
          >
            {{ $t("play_now") }}
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent, ref } from "vue";
import { Navigation } from "swiper";
import { useGameEntryBaseOnTabSelected } from "@/composables/useTheme";
import { store } from "@/store";
import { IGameBsi } from "@/models/bsiGameList";
import EnumEntranceLocation from "@/models/enums/enumEntranceLocation";

export default defineComponent({
  props: {
    activeTab: {
      type: String,
      require: true,
    },
  },
  setup(props) {
    const router = useRouter();
    const { gameEntrySelected } = useGameEntryBaseOnTabSelected();
    const authenticated = computed(() => store.state.auth);
    const selectedCasino = ref<IGameBsi>(gameEntrySelected.value[0]);
    const { getAssetImage, handleRemoveSpaceSpecialCharFormatted } =
      commonHelper;
    const isDisappear = ref(false);
    const currentIndex = ref(0);
    const imgName = ref<string | undefined>(
      gameEntrySelected.value[0] !== undefined
        ? handleRemoveSpaceSpecialCharFormatted(
            String(gameEntrySelected.value[0].EnglishGameName).concat(gameEntrySelected.value[0].GameProviderId === 1052 ? "new" : "")
          )
        : ""
    );
    const biggerIndex = ref(true);
    function checkBiggerIndex(idx: number) {
      if (currentIndex.value < idx) {
        biggerIndex.value = true;
      }
      if (currentIndex.value > idx) {
        biggerIndex.value = false;
      }
    }
    function checkImgName(imageName: string) {
      if (imageName.includes("sagaming")) {
        return "sagaming";
      }
      if (imageName.includes("sbo")) {
        return "sbo";
      }
      if (imageName.includes("568win")) {
        return "568win";
      }
      return imageName;
    }
    const animationClass = ref("");
    const checkTabClass = () => {
      if (props.activeTab !== "lottery") {
        animationClass.value = biggerIndex.value
          ? "casino_banner_left_to_right"
          : "casino_banner_left";
      } else {
        animationClass.value = !biggerIndex.value
          ? "casino_banner_left_to_right"
          : "casino_banner_left";
      }
    };
    const toggleTab = (sport: IGameBsi, currIndex: number) => {
      checkBiggerIndex(currIndex);
      checkTabClass();
      currentIndex.value = currIndex;
      isDisappear.value = !isDisappear.value;
      selectedCasino.value = sport;
      imgName.value = handleRemoveSpaceSpecialCharFormatted(
        String(sport.EnglishGameName).concat(sport.GameProviderId === 1052 ? "new" : "")
      );
      setTimeout(() => {
        isDisappear.value = !isDisappear.value;
      }, 1000);
    };
    const folderName = ref("");
    const bannerImg = ref("");
    function checkFolderName() {
      if (props.activeTab === "livecasino") {
        folderName.value = "casinoPage";
      }
      if (props.activeTab === "lottery") {
        folderName.value = "lotteryPage";
        bannerImg.value = "lottery";
      }
      if (props.activeTab === "poker") {
        folderName.value = "pokerPage";
      }
    }
    checkFolderName();
    const activeTabLiveCasino = props.activeTab === "livecasino";
    const animation = computed(() => animationClass.value);
    const handleImportImage = (path = "") => {
      try {
        return getAssetImage(`assets/theme${path}`);
      } catch (e) {
        return path;
      }
    };
    const onPlay = (gameId: number) => {
      const tab =
        props.activeTab === "livecasino" ? "live-casino" : props.activeTab;
      if (authenticated.value) {
        router.push(
          `/Game/${gameId}?tab=${tab}&&entrance=${EnumEntranceLocation.GameLobby}`
        );
        window.scrollTo({ top: 0, behavior: "smooth" });
      } else {
        router.push("/login");
      }
    };
    const btnBg = `url(${getAssetImage(
      "assets/theme/light_flexible_1/desktop/images/btn-background-active.png"
    )})`;
    return {
      toggleTab,
      isDisappear,
      gameEntrySelected,
      imgName,
      handleRemoveSpaceSpecialCharFormatted,
      selectedCasino,
      authenticated,
      folderName,
      bannerImg,
      currentIndex,
      animation,
      modules: [Navigation],
      checkImgName,
      EnumEntranceLocation,
      handleImportImage,
      onPlay,
      getAssetImage,
      btnBg,
      activeTabLiveCasino
    };
  },
});
</script>

<style lang="scss" scoped>
:deep(.swiper-slide, swiper-slide) {
  display: flex;
}
.sport-entry-play-button {
  background-image: var(--btnBg);
  background-size: contain;
  width: fit-content;
  min-width: 160px;
  height: 50px;
  color: white;
  cursor: pointer;
  transition: 0.3s ease-in-out;
  border-radius: 30px;
  padding: 0 10px;
}
.swiper {
  padding-top: 10px;
}
:deep(.casino-swiper .swiper-button-next) {
  translate: 8px -40px;
}
:deep(.casino-swiper .swiper-button-prev) {
  translate: -8px -40px;
}
:deep(.swiper-button-prev:after) {
  font-size: 15px;
}
:deep(.swiper-button-next:after) {
  font-size: 15px;
}
.casino_banner_left .v-enter-active,
.casino_banner_left .v-leave-active {
  transition: all 1s ease;
}

.casino_banner_left .v-leave-from {
  margin-left: 0;
  opacity: 1;
}
.casino_banner_left .v-enter-to {
  margin-left: 0;
  opacity: 1;
}
.casino_banner_left .v-leave-to {
  margin-left: -40px;
  opacity: 0;
}
.casino_banner_left .v-enter-from {
  margin-left: 40px;
  opacity: 0;
}
.casino_banner_left_to_right .v-enter-active,
.casino_banner_left_to_right .v-leave-active {
  transition: all 1s ease;
}

.casino_banner_left_to_right .v-leave-from {
  margin-left: 0;
  opacity: 1;
}
.casino_banner_left_to_right .v-enter-to {
  margin-left: 0;
  opacity: 1;
}
.casino_banner_left_to_right .v-leave-to {
  margin-left: 40px;
  opacity: 0;
}

.casino_banner_left_to_right .v-enter-from {
  margin-left: -40px;
  opacity: 0;
}
.sport_company_logo .v-enter-active,
.sport_company_logo .v-leave-active {
  transition: all 1s ease;
}
.sport_company_logo .v-leave-from {
  opacity: 1;
}
.sport_company_logo .v-leave-to {
  opacity: 0;
}
.sport_company_logo .v-enter-to {
  opacity: 1;
  margin-left: 0;
}

.sport_company_logo .v-enter-from {
  opacity: 0;
  margin-left: 50px;
}
.page-banner-logo .v-enter-active,
.page-banner-logo .v-leave-active {
  transition: all 1s ease;
}

.page-banner-logo .v-leave-from,
.page-banner-logo .v-enter-to {
  opacity: 1;
  top: 0;
}

.page-banner-logo .v-enter-from,
.page-banner-logo .v-leave-to {
  opacity: 0;
  top: -50px;
}
.coin_fade .v-enter-active,
.coin_fade .v-leave-active {
  transition: all 1s ease;
}

.coin_fade .v-leave-from,
.coin_fade .v-enter-to {
  opacity: 1;
}

.coin_fade .v-enter-from,
.coin_fade .v-leave-to {
  opacity: 0;
}
#pageBannerImg {
  position: absolute;
  display: block;
  width: 520px;
  height: 300px;
  margin-left: auto;
  margin-right: auto;
  cursor: inherit;
  z-index: 1;
}
.sport_ads {
  position: absolute;
  z-index: 2;
  top: 0;
  left: -65px;
  display: block;
}
</style>
